100 REMark Calendar - Print an annual calendar on A4 sheet
102 REMark pjwitte September 7th 2003
104 REMark V0.11, pjw, 2022 Jul 24, Qdos compatible (again - but only to 2028!)
106 REMark V0.12, pjw, 2022 Oct 03, SMSQ/E or Qdos/Minerva with DATE toolkit
108 REMark        Now works to 2096!
110 :
112 REMark  **  Define and Init
114 :
116 RESTORE
118 :
120 box% = 2:               REMark Grid size
122 fdow = 1:               REMark First day of week (Sun = 0..6)
124 lsp% = 2:               REMark Lines between boxes
126 Gut$ = FILL$(" ", 4):   REMark Gutter (spaces between boxes)
128 lmrg% = 8:              REMark Left margin
130 outp$ = 'ram1_Cal_txt': REMark Output device
132 :
134 Init
136 :
138 REMark  **  Output harness
140 :
142 ch = FOP_OVER(outp$)
144 PrtCal3x4 2096, 1: REMark Year and month (1..12) to start
146 CLOSE#ch
148 FI2_CALL outp$:         REMark Optional - or EX your favourite editor
150 :
152 REMark  **  12 month calendar in 3 x 4 grid
154 :
156 DEFine PROCedure PrtCal3x4(y%, stm%)
158 LOCal i, l, d, l%, m%, l$
160 GetMhd$: m% = stm%: l% = 0
162 FOR i = 1 TO 12
164  Calendar y% + l%, m%
166  m% = (m% MOD 12) + 1
168  IF m% = 1: l% = 1: REMark Flag new year
170 END FOR i
172 l% = 60 + LEN(Gut$) * 2: REMark Display width
174 PRINT#ch; TO lmrg%;
176 IF stm% <> 1 THEN
178  PRINT#ch; Center$(l%, 'Calendar for ' & y% & '/' & (y% + 1));
180 ELSE
182  PRINT#ch; Center$(l%, 'Calendar for ' & y%);
184 END IF
186 LF
188 m% = stm%
190 FOR i = 1 TO 12 STEP 3
192  REMark Print three months at a time
194  PRINT#ch; TO lmrg%; Center$(20, Mnth$(m%)); Gut$;
196  PRINT#ch; Center$(20, Mnth$((m% MOD 12) + 1)); Gut$;
198  PRINT#ch; Center$(20, Mnth$(((m% + 1) MOD 12) + 1));: LF
200 :
202  REMark Print weekday headers
204  FOR l = 1 TO 2: PRINT#ch; mhd$; Gut$;
206  PRINT#ch; mhd$;: LF
208 :
210  REMark Print one week line for each of 3 months
212  FOR l = 0 TO 5
214   l$ = ''
216   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%((m% + 11) MOD 12, l, d)) & FILL$(' ', d <> 6)
218   l$ = l$ & Gut$
220   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%(m% MOD 12, l, d)) & FILL$(' ', d <> 6)
222   l$ = l$ & Gut$
224   FOR d = 0 TO 6: l$ = l$ & Pad$(yr%((m% + 1) MOD 12, l, d)) & FILL$(' ', d <> 6)
226   FOR d = 1 TO LEN(l$)
228    IF l$(d) <> ' ': PRINT#ch; l$;: LF: EXIT d:
230   END FOR d
232  END FOR l
234  REMark Increment month, wrapping round year
236  m% = ((m% + 2) MOD 12) + 1
238 END FOR i
240 END DEFine PrtCal3x4
242 :
244 REMark  **  Date calculation stuff
246 :
248 DEFine PROCedure Init
250 LOCal i
252 DIM Mnth$(12, 10), Mnth%(12), yr%(11, 5, 6)
254 FOR i = 1 TO 12: READ Mnth$(i), Mnth%(i)
256 DATA 'January', -1, 'February', 30, 'March', 58, 'April', 89
258 DATA 'May', 119, 'June', 150, 'July', 180, 'August', 211
260 DATA 'September', 242, 'October', 272, 'November', 303, 'December', 333
262 END DEFine Init
264 :
266 DEFine PROCedure Calendar(y%, m%)
268 LOCal d, dy%, n%, l%
270 dy% = DOW%(y%, m%, 1): l% = 0: n% = m% - 1
272 FOR d = 1 TO LDM%(y%, m%)
274  dy% = DOW%(y%, m%, d)
276  yr%(n%, l%, dy%) = d
278  IF dy% = 6: l% = l% + 1
280 END FOR d
282 END DEFine Calendar
284 :
286 DEFine PROCedure GetMhd$
288 LOCal i, d$(4)
290 mhd$ = ''
292 FOR i = 0 TO 6
294  d$ = DAY$(86400 * (i + fdow))
296  mhd$ = mhd$ & d$(1 TO box%) & FILL$(' ', i <> 6)
298 END FOR i
300 END DEFine GetMhd$
302 :
304 DEFine FuNction LDM%(y%, m%)
306 LOCal dt$(20)
308 REMark Last date of month
310 dt$ = DATE$(Secs(y%, m%, 31))
312 IF dt$(10 TO 11) = 31: RETurn 31
314 RETurn 31 - dt$(10 TO 11)
316 END DEFine LDM%
318 :
320 DEFine FuNction DOW%(y%, m%, d%)
322 RETurn (WEEKDAY%(y%, m%, d%, 0, 0, 0) - fdow) MOD 7
324 END DEFine DOW%
326 :
328 DEFine FuNction Secs(y%, m%, d%)
330 RETurn DATE(y%, m%, d%, 0, 0, 0)
332 END DEFine Secs
334 :
336 REMark  **  Misc routines
338 :
340 DEFine FuNction Pad$(n%)
342 IF n% = 0 THEN
344  RETurn FILL$(" ", box%)
346 ELSE
348  RETurn FILL$(" ", box% - LEN(n%)) & n%
350 END IF
352 END DEFine Pad$
354 :
356 DEFine PROCedure LF
358 LOCal i
360 FOR i = 1 TO lsp%: PRINT#ch
362 PRINT#ch; TO lmrg%;
364 END DEFine LF
366 :
368 DEFine FuNction Center$(w%, tx$)
370 LOCal l%, f%
372 l% = LEN(tx$)
374 IF l% * w% = 0: RETurn FILL$(' ', w%)
376 IF l% > w% THEN
378  f% = INT((l% - w%) / 2 + .5)
380  RETurn tx$(f% TO INT(f% + w% - .5))
382 ELSE
384  f% = INT((w% - l%) / 2)
386  RETurn FILL$(' ', f%) & tx$ & FILL$(' ', w% - f% - l%)
388 END IF
390 END DEFine Center$
392 :
